﻿using System;

namespace HeuristicLab.Problems.ProgramSynthesis.Push.Extensions {
  using HeuristicLab.BenchmarkSuite;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;

  public static class ProblemDataExtensions {
    public static void InitInExpressions(this ProblemData data, IEnabledExpressionsConfiguration config) {
      if (data.TotalIntputArgumentCount >= 1) config.EnableExpression<In1Expression>();
      if (data.TotalIntputArgumentCount >= 2) config.EnableExpression<In2Expression>();
      if (data.TotalIntputArgumentCount >= 3) config.EnableExpression<In3Expression>();
      if (data.TotalIntputArgumentCount >= 4) config.EnableExpression<In4Expression>();
      if (data.TotalIntputArgumentCount >= 5) config.EnableExpression<In5Expression>();
      if (data.TotalIntputArgumentCount >= 6) config.EnableExpression<In6Expression>();
      if (data.TotalIntputArgumentCount >= 7) config.EnableExpression<In7Expression>();
      if (data.TotalIntputArgumentCount >= 8) config.EnableExpression<In8Expression>();
      if (data.TotalIntputArgumentCount >= 9) config.EnableExpression<In9Expression>();
      if (data.TotalIntputArgumentCount == 10) config.EnableExpression<In10Expression>();

      if (data.TotalIntputArgumentCount > 10)
        throw new InvalidOperationException("More input arguments defined as InExpressions types");
    }
  }
}
